searchNodes=[{"ref":"Mix.Tasks.Temple.Convert.html","title":"Mix.Tasks.Temple.Convert","type":"task","doc":"Converts HTML to Temple syntax Takes HTML from a file or from stdin and outputs temple syntax to stdout."},{"ref":"Mix.Tasks.Temple.Convert.html#run/1","title":"Mix.Tasks.Temple.Convert.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Temple.Gen.Html.html","title":"Mix.Tasks.Temple.Gen.Html","type":"task","doc":"Generates controller, views, and context for an HTML resource in Temple. mix temple.gen.html Accounts User users name:string age:integer The first argument is the context module followed by the schema module and its plural name (used as the schema table name). The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource. Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User). The schema is responsible for mapping the database fields into an Elixir struct. Overall, this generator will add the following files to lib/: a context module in lib/app/accounts.ex for the accounts API a schema in lib/app/accounts/user.ex, with an users table a view in lib/app_web/views/user_view.ex a controller in lib/app_web/controllers/user_controller.ex default CRUD templates in lib/app_web/templates/user A migration file for the repository and test files for the context and controller features will also be generated. The location of the web files (controllers, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration: config :my_app_web, :generators, context_app: :my_app Alternatively, the --context-app option may be supplied to the generator: mix phx.gen.html Sales User users --context-app warehouse Web namespace By default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example: mix phx.gen.html.temple Sales User users --web Sales Which would generate a lib/app_web/controllers/sales/user_controller.ex and lib/app_web/views/sales/user_view.ex. Generating without a schema or context file In some cases, you may wish to bootstrap HTML templates, controllers, and controller tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix phx.gen.html.temple Accounts User users --table cms_users binary_id Generated migration can use binary_id for schema&#39;s primary key and its references with option --binary-id. Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app, :generators, migration: true, binary_id: false, sample_binary_id: &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration. Read the documentation for phx.gen.schema for more information on attributes."},{"ref":"Mix.Tasks.Temple.Gen.Layout.html","title":"Mix.Tasks.Temple.Gen.Layout","type":"task","doc":"Generates a Phoenix layout file in Temple. mix temple.gen.layout"},{"ref":"Mix.Tasks.Temple.Gen.Layout.html#run/1","title":"Mix.Tasks.Temple.Gen.Layout.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Temple.UpdateMdnDocs.html","title":"Mix.Tasks.Temple.UpdateMdnDocs","type":"task","doc":""},{"ref":"Mix.Tasks.Temple.UpdateMdnDocs.html#run/1","title":"Mix.Tasks.Temple.UpdateMdnDocs.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Temple.html","title":"Temple","type":"module","doc":""},{"ref":"Temple.html#defcomponent/2","title":"Temple.defcomponent/2","type":"macro","doc":"Defines a custom component. Components are the primary way to extract partials and markup helpers. Assigns Components accept a keyword list or a map of assigns and can be referenced in the body of the component by a module attribute of the same name. This works exactly the same as EEx templates. Children If a block is passed to the component, it can be referenced by a special assign called @children. Example defcomponent :flex do div id: @id, class: &quot;flex&quot; do @children end end temple do flex id: &quot;my-flex&quot; do div &quot;Item 1&quot; div &quot;Item 2&quot; div &quot;Item 3&quot; end end # {:safe, &quot;&lt;div id=&quot;my-flex&quot; class=&quot;flex&quot;&gt; # &lt;div&gt;Item 1&lt;/div&gt; # &lt;div&gt;Item 2&lt;/div&gt; # &lt;div&gt;Item 3&lt;/div&gt; # &lt;/div&gt;&quot;}"},{"ref":"Temple.html#partial/1","title":"Temple.partial/1","type":"macro","doc":"Emits a Phoenix partial into the markup. temple do html lang: &quot;en&quot; do head do title &quot;MyApp&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do main role: &quot;main&quot;, class: &quot;container&quot; do p get_flash(@conn, :info), class: &quot;alert alert-info&quot;, role: &quot;alert&quot; p get_flash(@conn, :error), class: &quot;alert alert-danger&quot;, role: &quot;alert&quot; partial render(@view_module, @view_template, assigns) end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end end end"},{"ref":"Temple.html#temple/1","title":"Temple.temple/1","type":"macro","doc":"Creates a markup context. All tags must be called inside of a Temple.temple/1 block. Returns a safe result of the form {:safe, result} Example team = [&quot;Alice&quot;, &quot;Bob&quot;, &quot;Carol&quot;] temple do for name &lt;- team do div class: &quot;text-bold&quot; do text name end end end # {:safe, &quot;&lt;div class=&quot;text-bold&quot;&gt;Alice&lt;/div&gt;&lt;div class=&quot;text-bold&quot;&gt;Bob&lt;/div&gt;&lt;div class=&quot;text-bold&quot;&gt;Carol&lt;/div&gt;&quot;}"},{"ref":"Temple.html#text/1","title":"Temple.text/1","type":"macro","doc":"Emits a text node into the markup. temple do div do text &quot;Hello, world!&quot; end end # {:safe, &quot;&lt;div&gt;Hello, world!&lt;/div&gt;&quot;}"},{"ref":"Temple.Elements.html","title":"Temple.Elements","type":"module","doc":"This module contains the primitives used to generate the macros in the Temple.Html and Temple.Svg modules."},{"ref":"Temple.Elements.html#defelement/2","title":"Temple.Elements.defelement/2","type":"macro","doc":"Defines an element. Note: Underscores are converted to dashes. defmodule MyElements do import Temple.Elements defelement :super_select, :nonvoid # &lt;super-select&gt;&lt;/super-select&gt; defelement :super_input, :void # &lt;super-input&gt; end"},{"ref":"Temple.Engine.html","title":"Temple.Engine","type":"module","doc":"Temple provides a templating engine for use in Phoenix web applications. You can configure your application to use Temple templates by adding the following configuration. # config.exs config :phoenix, :template_engines, exs: Temple.Engine # your_app_web.ex def view do quote location: :keep do # ... use Temple # Replaces the call to import Phoenix.HTML end end Usage Temple templates use the .exs extension, because they are written with pure Elixir! assigns (@conn, etc) are handled the same as normal Phoenix.HTML.Engine templates. Note: The Temple.temple/1 macro is not needed for Temple templates due to the engine taking care of that for you. # app.html.exs html lang: &quot;en&quot; do head do meta charset: &quot;utf-8&quot; meta http_equiv: &quot;X-UA-Compatible&quot;, content: &quot;IE=edge&quot; meta name: &quot;viewport&quot;, content: &quot;width=device-width, initial-scale=1.0&quot; title &quot;YourApp · Phoenix Framework&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do header do section class: &quot;container&quot; do nav role: &quot;navigation&quot; do ul do li do: a(&quot;Get Started&quot;, href: &quot;https://hexdocs.pm/phoenix/overview.html&quot;) end end a href: &quot;http://phoenixframework.org/&quot;, class: &quot;phx-logo&quot; do img src: Routes.static_path(@conn, &quot;/images/phoenix.png&quot;), alt: &quot;Phoenix Framework Logo&quot; end end end main role: &quot;main&quot;, class: &quot;container&quot; do p get_flash(@conn, :info), class: &quot;alert alert-info&quot;, role: &quot;alert&quot; p get_flash(@conn, :error), class: &quot;alert alert-danger&quot;, role: &quot;alert&quot; partial render(@view_module, @view_template, assigns) end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end end"},{"ref":"Temple.Engine.html#compile/2","title":"Temple.Engine.compile/2","type":"function","doc":"Callback implementation for Phoenix.Template.Engine.compile/2."},{"ref":"Temple.Form.html","title":"Temple.Form","type":"module","doc":"This modules wraps all of the functions from the Phoenix.HTML.Form module to make them compatible with with Temple."},{"ref":"Temple.Form.html#checkbox/3","title":"Temple.Form.checkbox/3","type":"macro","doc":"Please see Phoenix.HTML.Form.checkbox/3 for details."},{"ref":"Temple.Form.html#color_input/3","title":"Temple.Form.color_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.color_input/3 for details."},{"ref":"Temple.Form.html#date_input/3","title":"Temple.Form.date_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.date_input/3 for details."},{"ref":"Temple.Form.html#date_select/3","title":"Temple.Form.date_select/3","type":"macro","doc":"Please see Phoenix.HTML.Form.date_select/3 for details."},{"ref":"Temple.Form.html#datetime_local_input/3","title":"Temple.Form.datetime_local_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.datetime_local_input/3 for details."},{"ref":"Temple.Form.html#datetime_select/3","title":"Temple.Form.datetime_select/3","type":"macro","doc":"Please see Phoenix.HTML.Form.datetime_select/3 for details."},{"ref":"Temple.Form.html#email_input/3","title":"Temple.Form.email_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.email_input/3 for details."},{"ref":"Temple.Form.html#file_input/3","title":"Temple.Form.file_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.file_input/3 for details."},{"ref":"Temple.Form.html#form_for/2","title":"Temple.Form.form_for/2","type":"macro","doc":"Generates an empty form tag. See Temple.Form.form_for/4 for more details"},{"ref":"Temple.Form.html#form_for/4","title":"Temple.Form.form_for/4","type":"macro","doc":"Generates a form tag with a form builder and a block. The form builder will be available inside the block through the form variable. This is a wrapper around the Phoenix.HTML.Form.form_for/4 function and accepts all of the same options. Example temple do form_for @conn, Routes.some_path(@conn, :create) do text_input form, :name end end # {:safe, # &quot;&lt;form accept-charset=&quot;UTF-8&quot; action=&quot;/&quot; method=&quot;post&quot;&gt; # &lt;input name=&quot;_csrf_token&quot; type=&quot;hidden&quot; value=&quot;AS5qfX1gcns6eU56BlQgBlwCDgMlNgAAiJ0MR91Kh3v3bbCS5SKjuw==&quot;&gt; # &lt;input name=&quot;_utf8&quot; type=&quot;hidden&quot; value=&quot;✓&quot;&gt; # &lt;input id=&quot;name&quot; name=&quot;name&quot; type=&quot;text&quot;&gt; # &lt;/form&gt;&quot;}"},{"ref":"Temple.Form.html#hidden_input/3","title":"Temple.Form.hidden_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.hidden_input/3 for details."},{"ref":"Temple.Form.html#inputs_for/4","title":"Temple.Form.inputs_for/4","type":"macro","doc":"Generate a new form builder for the given parameter in form. The form builder will be available inside the block through the inner_form variable. This is a wrapper around the Phoenix.HTML.Form.inputs_for/4 function and accepts all of the same options. Example temple do form_for @parent, Routes.some_path(@conn, :create) do text_input form, :name inputs_for form, :job do text_input inner_form, :description end inputs_for form, :children do text_input inner_form, :name end end end # {:safe, # &quot;&lt;form accept-charset=&quot;UTF-8&quot; action=&quot;/&quot; method=&quot;post&quot;&gt; # &lt;input name=&quot;_csrf_token&quot; type=&quot;hidden&quot; value=&quot;AS5qfX1gcns6eU56BlQgBlwCDgMlNgAAiJ0MR91Kh3v3bbCS5SKjuw==&quot;&gt; # &lt;input name=&quot;_utf8&quot; type=&quot;hidden&quot; value=&quot;✓&quot;&gt; # &lt;input id=&quot;name&quot; name=&quot;parent[name]&quot; type=&quot;text&quot;&gt; # # &lt;input id=&quot;name&quot; name=&quot;parent[job][description]&quot; type=&quot;text&quot;&gt; # # &lt;input id=&quot;name&quot; name=&quot;parent[children][1][name]&quot; type=&quot;text&quot;&gt; # &lt;input id=&quot;name&quot; name=&quot;parent[children][2][name]&quot; type=&quot;text&quot;&gt; # &lt;/form&gt;&quot;}"},{"ref":"Temple.Form.html#multiple_select/4","title":"Temple.Form.multiple_select/4","type":"macro","doc":"Please see Phoenix.HTML.Form.multiple_select/4 for details."},{"ref":"Temple.Form.html#number_input/3","title":"Temple.Form.number_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.number_input/3 for details."},{"ref":"Temple.Form.html#password_input/3","title":"Temple.Form.password_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.password_input/3 for details."},{"ref":"Temple.Form.html#phx_label/2","title":"Temple.Form.phx_label/2","type":"macro","doc":"Please see Phoenix.HTML.Form.label/2 for details."},{"ref":"Temple.Form.html#phx_label/3","title":"Temple.Form.phx_label/3","type":"macro","doc":"Please see Phoenix.HTML.Form.label/3 for details."},{"ref":"Temple.Form.html#phx_label/4","title":"Temple.Form.phx_label/4","type":"macro","doc":"Please see Phoenix.HTML.Form.label/4 for details."},{"ref":"Temple.Form.html#radio_button/4","title":"Temple.Form.radio_button/4","type":"macro","doc":"Please see Phoenix.HTML.Form.radio_button/4 for details."},{"ref":"Temple.Form.html#range_input/3","title":"Temple.Form.range_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.range_input/3 for details."},{"ref":"Temple.Form.html#reset/2","title":"Temple.Form.reset/2","type":"macro","doc":"Please see Phoenix.HTML.Form.reset/2 for details."},{"ref":"Temple.Form.html#search_input/3","title":"Temple.Form.search_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.search_input/3 for details."},{"ref":"Temple.Form.html#select/4","title":"Temple.Form.select/4","type":"macro","doc":"Please see Phoenix.HTML.Form.select/4 for details."},{"ref":"Temple.Form.html#submit/1","title":"Temple.Form.submit/1","type":"macro","doc":"Please see Phoenix.HTML.Form.submit/1 for details."},{"ref":"Temple.Form.html#submit/2","title":"Temple.Form.submit/2","type":"macro","doc":"Please see Phoenix.HTML.Form.submit/1 for details."},{"ref":"Temple.Form.html#telephone_input/3","title":"Temple.Form.telephone_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.telephone_input/3 for details."},{"ref":"Temple.Form.html#text_area/3","title":"Temple.Form.text_area/3","type":"macro","doc":"Please see Phoenix.HTML.Form.textarea/3 for details. Note: Temple defines this function as text_area with an underscore, whereas Phoenix.HTML defines it as textarea without an underscore."},{"ref":"Temple.Form.html#text_input/3","title":"Temple.Form.text_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.text_input/3 for details."},{"ref":"Temple.Form.html#time_input/3","title":"Temple.Form.time_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.time_input/3 for details."},{"ref":"Temple.Form.html#time_select/3","title":"Temple.Form.time_select/3","type":"macro","doc":"Please see Phoenix.HTML.Form.time_select/3 for details."},{"ref":"Temple.Form.html#url_input/3","title":"Temple.Form.url_input/3","type":"macro","doc":"Please see Phoenix.HTML.Form.url_input/3 for details."},{"ref":"Temple.Html.html","title":"Temple.Html","type":"module","doc":"The Temple.Html module defines macros for all HTML5 compliant elements. Temple.Html macros must be called inside of a Temple.temple/1 block. Note: Only the lowest arity macros are documented. Void elements are defined as a 1-arity macro and non-void elements are defined as 0, 1, and 2-arity macros. Attributes Html accept a keyword list or a map of attributes to be emitted into the element&#39;s opening tag. Multi-word attribute keys written in snake_case (data_url) will be transformed into kebab-case (data-url). Children Non-void elements (such as div) accept a block that can be used to nest other tags or text nodes. These blocks can contain arbitrary Elixir code such as variables and for comprehensions. If you are only emitting a text node within a block, you can use the shortened syntax by passing the text in as the first parameter of the tag. Example temple do # empty non-void element div() # non-void element with keyword list attributes div class: &quot;text-red&quot;, id: &quot;my-el&quot; # non-void element with map attributes div %{:class =&gt; &quot;text-red&quot;, &quot;id&quot; =&gt; &quot;my-el&quot;} # non-void element with children div do text &quot;Hello, world!&quot; for name &lt;- @names do div data_name: name end end # non-void element with a single text node div &quot;Hello, world!&quot;, class: &quot;text-green&quot; # void elements input name: &quot;comments&quot;, placeholder: &quot;Enter a comment...&quot; end # {:safe, # &quot;&lt;div&gt;&lt;/div&gt; # &lt;div class=&quot;text-red&quot; id=&quot;my-el&quot;&gt;&lt;/div&gt; # &lt;div&gt; # Hello, world! # &lt;div data-name=&quot;Alice&quot;&gt;&lt;/div&gt; # &lt;div data-name=&quot;Bob&quot;&gt;&lt;/div&gt; # &lt;div data-name=&quot;Carol&quot;&gt;&lt;/div&gt; # &lt;/div&gt; # &lt;div class=&quot;text-green&quot;&gt;Hello, world!&lt;/div&gt; # &lt;input name=&quot;comments&quot; placeholder=&quot;Enter a comment...&quot;&gt;&quot; # }"},{"ref":"Temple.Html.html#a/0","title":"Temple.Html.a/0","type":"macro","doc":"The HTML &lt;a&gt; element (or anchor element), along with its href attribute, creates a hyperlink to other web pages, files, locations within the same page, email addresses, or any other URL."},{"ref":"Temple.Html.html#abbr/0","title":"Temple.Html.abbr/0","type":"macro","doc":"The HTML Abbreviation element (&lt;abbr&gt;) represents an abbreviation or acronym; the optional title attribute can provide an expansion or description for the abbreviation."},{"ref":"Temple.Html.html#address/0","title":"Temple.Html.address/0","type":"macro","doc":"The HTML &lt;address&gt; element indicates that the enclosed HTML provides contact information for a person or people, or for an organization."},{"ref":"Temple.Html.html#area/1","title":"Temple.Html.area/1","type":"macro","doc":"The HTML &lt;area&gt; element defines a hot-spot region on an image, and optionally associates it with a hypertext link. This element is used only within a &lt;map&gt; element."},{"ref":"Temple.Html.html#article/0","title":"Temple.Html.article/0","type":"macro","doc":"The HTML &lt;article&gt; element represents a self-contained composition in a document, page, application, or site, which is intended to be independently distributable or reusable (e.g., in syndication)."},{"ref":"Temple.Html.html#aside/0","title":"Temple.Html.aside/0","type":"macro","doc":"The HTML &lt;aside&gt; element represents a portion of a document whose content is only indirectly related to the document&#39;s main content."},{"ref":"Temple.Html.html#audio/0","title":"Temple.Html.audio/0","type":"macro","doc":"The HTML &lt;audio&gt; element is used to embed sound content in documents. It may contain one or more audio sources, represented using the src attribute or the &lt;source&gt; element: the browser will choose the most suitable one. It can also be the destination for streamed media, using a MediaStream."},{"ref":"Temple.Html.html#b/0","title":"Temple.Html.b/0","type":"macro","doc":"The HTML Bring Attention To element (&lt;b&gt;)  is used to draw the reader&#39;s attention to the element&#39;s contents, which are not otherwise granted special importance."},{"ref":"Temple.Html.html#base/1","title":"Temple.Html.base/1","type":"macro","doc":"The HTML &lt;base&gt; element specifies the base URL to use for all relative URLs contained within a document. There can be only one &lt;base&gt; element in a document."},{"ref":"Temple.Html.html#bdi/0","title":"Temple.Html.bdi/0","type":"macro","doc":"The HTML Bidirectional Isolate element (&lt;bdi&gt;)  tells the browser&#39;s bidirectional algorithm to treat the text it contains in isolation from its surrounding text."},{"ref":"Temple.Html.html#bdo/0","title":"Temple.Html.bdo/0","type":"macro","doc":"The HTML Bidirectional Text Override element (&lt;bdo&gt;) overrides the current directionality of text, so that the text within is rendered in a different direction."},{"ref":"Temple.Html.html#blockquote/0","title":"Temple.Html.blockquote/0","type":"macro","doc":"The HTML &lt;blockquote&gt; Element (or HTML Block Quotation Element) indicates that the enclosed text is an extended quotation. Usually, this is rendered visually by indentation (see Notes for how to change it). A URL for the source of the quotation may be given using the cite attribute, while a text representation of the source can be given using the &lt;cite&gt; element."},{"ref":"Temple.Html.html#body/0","title":"Temple.Html.body/0","type":"macro","doc":"The HTML &lt;body&gt; Element represents the content of an HTML document. There can be only one &lt;body&gt; element in a document."},{"ref":"Temple.Html.html#br/1","title":"Temple.Html.br/1","type":"macro","doc":"The HTML &lt;br&gt; element produces a line break in text (carriage-return). It is useful for writing a poem or an address, where the division of lines is significant."},{"ref":"Temple.Html.html#button/0","title":"Temple.Html.button/0","type":"macro","doc":"The HTML &lt;button&gt; element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality."},{"ref":"Temple.Html.html#canvas/0","title":"Temple.Html.canvas/0","type":"macro","doc":"Use the HTML &lt;canvas&gt; element with either the canvas scripting API or the WebGL API to draw graphics and animations."},{"ref":"Temple.Html.html#caption/0","title":"Temple.Html.caption/0","type":"macro","doc":"The HTML Table Caption element (&lt;caption&gt;) specifies the caption (or title) of a table, and if used is always the first child of a &lt;table&gt;."},{"ref":"Temple.Html.html#cite/0","title":"Temple.Html.cite/0","type":"macro","doc":"The HTML Citation element (&lt;cite&gt;) is used to describe a reference to a cited creative work, and must include the title of that work."},{"ref":"Temple.Html.html#code/0","title":"Temple.Html.code/0","type":"macro","doc":"The HTML &lt;code&gt; element displays its contents styled in a fashion intended to indicate that the text is a short fragment of computer code."},{"ref":"Temple.Html.html#col/1","title":"Temple.Html.col/1","type":"macro","doc":"The HTML &lt;col&gt; element defines a column within a table and is used for defining common semantics on all common cells. It is generally found within a &lt;colgroup&gt; element."},{"ref":"Temple.Html.html#colgroup/0","title":"Temple.Html.colgroup/0","type":"macro","doc":"The HTML &lt;colgroup&gt; element defines a group of columns within a table."},{"ref":"Temple.Html.html#data/0","title":"Temple.Html.data/0","type":"macro","doc":"The HTML &lt;data&gt; element links a given content with a machine-readable translation. If the content is time- or date-related, the &lt;time&gt; element must be used."},{"ref":"Temple.Html.html#datalist/0","title":"Temple.Html.datalist/0","type":"macro","doc":"The HTML &lt;datalist&gt; element contains a set of &lt;option&gt; elements that represent the values available for other controls."},{"ref":"Temple.Html.html#dd/0","title":"Temple.Html.dd/0","type":"macro","doc":"The HTML &lt;dd&gt; element provides the description, definition, or value for the preceding term (&lt;dt&gt;) in a description list (&lt;dl&gt;)."},{"ref":"Temple.Html.html#del/0","title":"Temple.Html.del/0","type":"macro","doc":"The HTML &lt;del&gt; element represents a range of text that has been deleted from a document."},{"ref":"Temple.Html.html#details/0","title":"Temple.Html.details/0","type":"macro","doc":"The HTML Details Element (&lt;details&gt;) creates a disclosure widget in which information is visible only when the widget is toggled into an &quot;open&quot; state."},{"ref":"Temple.Html.html#dfn/0","title":"Temple.Html.dfn/0","type":"macro","doc":"The HTML Definition element (&lt;dfn&gt;) is used to indicate the term being defined within the context of a definition phrase or sentence."},{"ref":"Temple.Html.html#div/0","title":"Temple.Html.div/0","type":"macro","doc":"The HTML Content Division element (&lt;div&gt;) is the generic container for flow content. It has no effect on the content or layout until styled using CSS."},{"ref":"Temple.Html.html#dl/0","title":"Temple.Html.dl/0","type":"macro","doc":"The HTML &lt;dl&gt; element represents a description list. The element encloses a list of groups of terms (specified using the &lt;dt&gt; element) and descriptions (provided by &lt;dd&gt; elements). Common uses for this element are to implement a glossary or to display metadata (a list of key-value pairs)."},{"ref":"Temple.Html.html#dt/0","title":"Temple.Html.dt/0","type":"macro","doc":"The HTML &lt;dt&gt; element specifies a term in a description or definition list, and as such must be used inside a &lt;dl&gt; element."},{"ref":"Temple.Html.html#em/0","title":"Temple.Html.em/0","type":"macro","doc":"The HTML &lt;em&gt; element marks text that has stress emphasis. The &lt;em&gt; element can be nested, with each level of nesting indicating a greater degree of emphasis."},{"ref":"Temple.Html.html#embed/1","title":"Temple.Html.embed/1","type":"macro","doc":"The HTML &lt;embed&gt; element embeds external content at the specified point in the document. This content is provided by an external application or other source of interactive content such as a browser plug-in."},{"ref":"Temple.Html.html#fieldset/0","title":"Temple.Html.fieldset/0","type":"macro","doc":"The HTML &lt;fieldset&gt; element is used to group several controls as well as labels (&lt;label&gt;) within a web form."},{"ref":"Temple.Html.html#figcaption/0","title":"Temple.Html.figcaption/0","type":"macro","doc":"The HTML &lt;figcaption&gt; or Figure Caption element represents a caption or legend describing the rest of the contents of its parent &lt;figure&gt; element."},{"ref":"Temple.Html.html#figure/0","title":"Temple.Html.figure/0","type":"macro","doc":"The HTML &lt;figure&gt; (Figure With Optional Caption) element represents self-contained content, potentially with an optional caption, which is specified using the (&lt;figcaption&gt;) element."},{"ref":"Temple.Html.html#footer/0","title":"Temple.Html.footer/0","type":"macro","doc":"The HTML &lt;footer&gt; element represents a footer for its nearest sectioning content or sectioning root element. A footer typically contains information about the author of the section, copyright data or links to related documents."},{"ref":"Temple.Html.html#form/0","title":"Temple.Html.form/0","type":"macro","doc":"The HTML &lt;form&gt; element represents a document section that contains interactive controls for submitting information to a web server."},{"ref":"Temple.Html.html#h1/0","title":"Temple.Html.h1/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Html.html#h2/0","title":"Temple.Html.h2/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Html.html#h3/0","title":"Temple.Html.h3/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Html.html#h4/0","title":"Temple.Html.h4/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Html.html#h5/0","title":"Temple.Html.h5/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Html.html#h6/0","title":"Temple.Html.h6/0","type":"macro","doc":"The HTML &lt;h1&gt;–&lt;h6&gt; elements represent six levels of section headings. &lt;h1&gt; is the highest section level and &lt;h6&gt; is the lowest."},{"ref":"Temple.Html.html#head/0","title":"Temple.Html.head/0","type":"macro","doc":"The HTML &lt;head&gt; element contains machine-readable information (metadata) about the document, like its title, scripts, and style sheets."},{"ref":"Temple.Html.html#header/0","title":"Temple.Html.header/0","type":"macro","doc":"The HTML &lt;header&gt; element represents introductory content, typically a group of introductory or navigational aids. It may contain some heading elements but also a logo, a search form, an author name, and other elements."},{"ref":"Temple.Html.html#hr/1","title":"Temple.Html.hr/1","type":"macro","doc":"The HTML &lt;hr&gt; element represents a thematic break between paragraph-level elements: for example, a change of scene in a story, or a shift of topic within a section."},{"ref":"Temple.Html.html#html/2","title":"Temple.Html.html/2","type":"macro","doc":"The HTML &lt;html&gt; element represents the root (top-level element) of an HTML document, so it is also referred to as the root element. All other elements must be descendants of this element."},{"ref":"Temple.Html.html#i/0","title":"Temple.Html.i/0","type":"macro","doc":"The HTML &lt;i&gt; element represents a range of text that is set off from the normal text for some reason. Some examples include technical terms, foreign language phrases, or fictional character thoughts. It is typically displayed in italic type."},{"ref":"Temple.Html.html#iframe/0","title":"Temple.Html.iframe/0","type":"macro","doc":"The HTML Inline Frame element (&lt;iframe&gt;) represents a nested browsing context, embedding another HTML page into the current one."},{"ref":"Temple.Html.html#img/1","title":"Temple.Html.img/1","type":"macro","doc":"The HTML &lt;img&gt; element embeds an image into the document."},{"ref":"Temple.Html.html#input/1","title":"Temple.Html.input/1","type":"macro","doc":"The HTML &lt;input&gt; element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent."},{"ref":"Temple.Html.html#ins/0","title":"Temple.Html.ins/0","type":"macro","doc":"The HTML &lt;ins&gt; element represents a range of text that has been added to a document."},{"ref":"Temple.Html.html#kbd/0","title":"Temple.Html.kbd/0","type":"macro","doc":"The HTML Keyboard Input element (&lt;kbd&gt;) represents a span of inline text denoting textual user input from a keyboard, voice input, or any other text entry device."},{"ref":"Temple.Html.html#keygen/1","title":"Temple.Html.keygen/1","type":"macro","doc":"The HTML &lt;keygen&gt; element exists to facilitate generation of key material, and submission of the public key as part of an HTML form. This mechanism is designed for use with Web-based certificate management systems. It is expected that the &lt;keygen&gt; element will be used in an HTML form along with other information needed to construct a certificate request, and that the result of the process will be a signed certificate."},{"ref":"Temple.Html.html#label/0","title":"Temple.Html.label/0","type":"macro","doc":"The HTML &lt;label&gt; element represents a caption for an item in a user interface."},{"ref":"Temple.Html.html#legend/0","title":"Temple.Html.legend/0","type":"macro","doc":"The HTML &lt;legend&gt; element represents a caption for the content of its parent &lt;fieldset&gt;."},{"ref":"Temple.Html.html#li/0","title":"Temple.Html.li/0","type":"macro","doc":"The HTML &lt;li&gt; element is used to represent an item in a list."},{"ref":"Temple.Html.html#link/1","title":"Temple.Html.link/1","type":"macro","doc":"The HTML External Resource Link element (&lt;link&gt;) specifies relationships between the current document and an external resource. This element is most commonly used to link to stylesheets, but is also used to establish site icons (both &quot;favicon&quot; style icons and icons for the home screen and apps on mobile devices) among other things."},{"ref":"Temple.Html.html#main/0","title":"Temple.Html.main/0","type":"macro","doc":"The HTML &lt;main&gt; element represents the dominant content of the &lt;body&gt; of a document. The main content area consists of content that is directly related to or expands upon the central topic of a document, or the central functionality of an application."},{"ref":"Temple.Html.html#map/0","title":"Temple.Html.map/0","type":"macro","doc":"The HTML &lt;map&gt; element is used with &lt;area&gt; elements to define an image map (a clickable link area)."},{"ref":"Temple.Html.html#mark/0","title":"Temple.Html.mark/0","type":"macro","doc":"The HTML Mark Text element (&lt;mark&gt;) represents text which is marked or highlighted for reference or notation purposes, due to the marked passage&#39;s relevance or importance in the enclosing context."},{"ref":"Temple.Html.html#menu/0","title":"Temple.Html.menu/0","type":"macro","doc":"The HTML &lt;menu&gt; element represents a group of commands that a user can perform or activate. This includes both list menus, which might appear across the top of a screen, as well as context menus, such as those that might appear underneath a button after it has been clicked."},{"ref":"Temple.Html.html#menuitem/0","title":"Temple.Html.menuitem/0","type":"macro","doc":"The HTML &lt;menuitem&gt; element represents a command that a user is able to invoke through a popup menu. This includes context menus, as well as menus that might be attached to a menu button."},{"ref":"Temple.Html.html#meta/1","title":"Temple.Html.meta/1","type":"macro","doc":"The HTML &lt;meta&gt; element represents metadata that cannot be represented by other HTML meta-related elements, like &lt;base&gt;, &lt;link&gt;, &lt;script&gt;, &lt;style&gt; or &lt;title&gt;."},{"ref":"Temple.Html.html#meter/0","title":"Temple.Html.meter/0","type":"macro","doc":"The HTML &lt;meter&gt; element represents either a scalar value within a known range or a fractional value."},{"ref":"Temple.Html.html#nav/0","title":"Temple.Html.nav/0","type":"macro","doc":"The HTML &lt;nav&gt; element represents a section of a page whose purpose is to provide navigation links, either within the current document or to other documents. Common examples of navigation sections are menus, tables of contents, and indexes."},{"ref":"Temple.Html.html#noscript/0","title":"Temple.Html.noscript/0","type":"macro","doc":"The HTML &lt;noscript&gt; element defines a section of HTML to be inserted if a script type on the page is unsupported or if scripting is currently turned off in the browser."},{"ref":"Temple.Html.html#object/0","title":"Temple.Html.object/0","type":"macro","doc":"The HTML &lt;object&gt; element represents an external resource, which can be treated as an image, a nested browsing context, or a resource to be handled by a plugin."},{"ref":"Temple.Html.html#ol/0","title":"Temple.Html.ol/0","type":"macro","doc":"The HTML &lt;ol&gt; element represents an ordered list of items, typically rendered as a numbered list."},{"ref":"Temple.Html.html#optgroup/0","title":"Temple.Html.optgroup/0","type":"macro","doc":"The HTML &lt;optgroup&gt; element creates a grouping of options within a &lt;select&gt; element."},{"ref":"Temple.Html.html#option/0","title":"Temple.Html.option/0","type":"macro","doc":"The HTML &lt;option&gt; element is used to define an item contained in a &lt;select&gt;, an &lt;optgroup&gt;, or a &lt;datalist&gt; element. As such, &lt;option&gt; can represent menu items in popups and other lists of items in an HTML document."},{"ref":"Temple.Html.html#output/0","title":"Temple.Html.output/0","type":"macro","doc":"The HTML Output element (&lt;output&gt;) is a container element into which a site or app can inject the results of a calculation or the outcome of a user action."},{"ref":"Temple.Html.html#p/0","title":"Temple.Html.p/0","type":"macro","doc":"The HTML &lt;p&gt; element represents a paragraph."},{"ref":"Temple.Html.html#param/1","title":"Temple.Html.param/1","type":"macro","doc":"The HTML &lt;param&gt; element defines parameters for an &lt;object&gt; element."},{"ref":"Temple.Html.html#pre/0","title":"Temple.Html.pre/0","type":"macro","doc":"The HTML &lt;pre&gt; element represents preformatted text which is to be presented exactly as written in the HTML file."},{"ref":"Temple.Html.html#progress/0","title":"Temple.Html.progress/0","type":"macro","doc":"The HTML &lt;progress&gt; element displays an indicator showing the completion progress of a task, typically displayed as a progress bar."},{"ref":"Temple.Html.html#q/0","title":"Temple.Html.q/0","type":"macro","doc":"The HTML &lt;q&gt; element indicates that the enclosed text is a short inline quotation. Most modern browsers implement this by surrounding the text in quotation marks."},{"ref":"Temple.Html.html#rp/0","title":"Temple.Html.rp/0","type":"macro","doc":"The HTML Ruby Fallback Parenthesis (&lt;rp&gt;) element is used to provide fall-back parentheses for browsers that do not support display of ruby annotations using the &lt;ruby&gt; element."},{"ref":"Temple.Html.html#rt/0","title":"Temple.Html.rt/0","type":"macro","doc":"The HTML Ruby Text (&lt;rt&gt;) element specifies the ruby text component of a ruby annotation, which is used to provide pronunciation, translation, or transliteration information for East Asian typography. The &lt;rt&gt; element must always be contained within a &lt;ruby&gt; element."},{"ref":"Temple.Html.html#ruby/0","title":"Temple.Html.ruby/0","type":"macro","doc":"The HTML &lt;ruby&gt; element represents a ruby annotation. Ruby annotations are for showing pronunciation of East Asian characters."},{"ref":"Temple.Html.html#s/0","title":"Temple.Html.s/0","type":"macro","doc":"The HTML &lt;s&gt; element renders text with a strikethrough, or a line through it. Use the &lt;s&gt; element to represent things that are no longer relevant or no longer accurate. However, &lt;s&gt; is not appropriate when indicating document edits; for that, use the &lt;del&gt; and &lt;ins&gt; elements, as appropriate."},{"ref":"Temple.Html.html#samp/0","title":"Temple.Html.samp/0","type":"macro","doc":"The HTML Sample Element (&lt;samp&gt;) is used to enclose inline text which represents sample (or quoted) output from a computer program."},{"ref":"Temple.Html.html#script/0","title":"Temple.Html.script/0","type":"macro","doc":"The HTML &lt;script&gt; element is used to embed or reference executable code; this is typically used to embed or refer to JavaScript code."},{"ref":"Temple.Html.html#section/0","title":"Temple.Html.section/0","type":"macro","doc":"The HTML &lt;section&gt; element represents a standalone section — which doesn&#39;t have a more specific semantic element to represent it — contained within an HTML document."},{"ref":"Temple.Html.html#select/0","title":"Temple.Html.select/0","type":"macro","doc":"The HTML &lt;select&gt; element represents a control that provides a menu of options"},{"ref":"Temple.Html.html#small/0","title":"Temple.Html.small/0","type":"macro","doc":"The HTML &lt;small&gt; element represents side-comments and small print, like copyright and legal text, independent of its styled presentation. By default, it renders text within it one font-size small, such as from small to x-small."},{"ref":"Temple.Html.html#source/1","title":"Temple.Html.source/1","type":"macro","doc":"The HTML &lt;source&gt; element specifies multiple media resources for the &lt;picture&gt;, the &lt;audio&gt; element, or the &lt;video&gt; element."},{"ref":"Temple.Html.html#span/0","title":"Temple.Html.span/0","type":"macro","doc":"The HTML &lt;span&gt; element is a generic inline container for phrasing content, which does not inherently represent anything. It can be used to group elements for styling purposes (using the class or id attributes), or because they share attribute values, such as lang."},{"ref":"Temple.Html.html#strong/0","title":"Temple.Html.strong/0","type":"macro","doc":"The HTML Strong Importance Element (&lt;strong&gt;) indicates that its contents have strong importance, seriousness, or urgency. Browsers typically render the contents in bold type."},{"ref":"Temple.Html.html#style/0","title":"Temple.Html.style/0","type":"macro","doc":"The HTML &lt;style&gt; element contains style information for a document, or part of a document."},{"ref":"Temple.Html.html#sub/0","title":"Temple.Html.sub/0","type":"macro","doc":"The HTML Subscript element (&lt;sub&gt;) specifies inline text which should be displayed as subscript for solely typographical reasons."},{"ref":"Temple.Html.html#summary/0","title":"Temple.Html.summary/0","type":"macro","doc":"The HTML Disclosure Summary element (&lt;summary&gt;) element specifies a summary, caption, or legend for a &lt;details&gt; element&#39;s disclosure box."},{"ref":"Temple.Html.html#sup/0","title":"Temple.Html.sup/0","type":"macro","doc":"The HTML Superscript element (&lt;sup&gt;) specifies inline text which is to be displayed as superscript for solely typographical reasons."},{"ref":"Temple.Html.html#table/0","title":"Temple.Html.table/0","type":"macro","doc":"The HTML &lt;table&gt; element represents tabular data — that is, information presented in a two-dimensional table comprised of rows and columns of cells containing data."},{"ref":"Temple.Html.html#tbody/0","title":"Temple.Html.tbody/0","type":"macro","doc":"The HTML Table Body element (&lt;tbody&gt;) encapsulates a set of table rows (&lt;tr&gt; elements), indicating that they comprise the body of the table (&lt;table&gt;)."},{"ref":"Temple.Html.html#td/0","title":"Temple.Html.td/0","type":"macro","doc":"The HTML &lt;td&gt; element defines a cell of a table that contains data. It participates in the table model."},{"ref":"Temple.Html.html#template/0","title":"Temple.Html.template/0","type":"macro","doc":"The HTML Content Template (&lt;template&gt;) element is a mechanism for holding HTML that is not to be rendered immediately when a page is loaded but may be instantiated subsequently during runtime using JavaScript."},{"ref":"Temple.Html.html#textarea/0","title":"Temple.Html.textarea/0","type":"macro","doc":"The HTML &lt;textarea&gt; element represents a multi-line plain-text editing control, useful when you want to allow users to enter a sizeable amount of free-form text, for example a comment on a review or feedback form."},{"ref":"Temple.Html.html#tfoot/0","title":"Temple.Html.tfoot/0","type":"macro","doc":"The HTML &lt;tfoot&gt; element defines a set of rows summarizing the columns of the table."},{"ref":"Temple.Html.html#th/0","title":"Temple.Html.th/0","type":"macro","doc":"The HTML &lt;th&gt; element defines a cell as header of a group of table cells. The exact nature of this group is defined by the scope and headers attributes."},{"ref":"Temple.Html.html#thead/0","title":"Temple.Html.thead/0","type":"macro","doc":"The HTML &lt;thead&gt; element defines a set of rows defining the head of the columns of the table."},{"ref":"Temple.Html.html#time/0","title":"Temple.Html.time/0","type":"macro","doc":"The HTML &lt;time&gt; element represents a specific period in time."},{"ref":"Temple.Html.html#title/0","title":"Temple.Html.title/0","type":"macro","doc":"The HTML Title element (&lt;title&gt;) defines the document&#39;s title that is shown in a browser&#39;s title bar or a page&#39;s tab."},{"ref":"Temple.Html.html#tr/0","title":"Temple.Html.tr/0","type":"macro","doc":"The HTML &lt;tr&gt; element defines a row of cells in a table. The row&#39;s cells can then be established using a mix of &lt;td&gt; (data cell) and &lt;th&gt; (header cell) elements."},{"ref":"Temple.Html.html#track/1","title":"Temple.Html.track/1","type":"macro","doc":"The HTML &lt;track&gt; element is used as a child of the media elements &lt;audio&gt; and &lt;video&gt;. It lets you specify timed text tracks (or time-based data), for example to automatically handle subtitles. The tracks are formatted in WebVTT format (.vtt files) — Web Video Text Tracks or Timed Text Markup Language (TTML)."},{"ref":"Temple.Html.html#u/0","title":"Temple.Html.u/0","type":"macro","doc":"The HTML Unarticulated Annotation Element (&lt;u&gt;) represents a span of inline text which should be rendered in a way that indicates that it has a non-textual annotation."},{"ref":"Temple.Html.html#ul/0","title":"Temple.Html.ul/0","type":"macro","doc":"The HTML &lt;ul&gt; element represents an unordered list of items, typically rendered as a bulleted list."},{"ref":"Temple.Html.html#var/0","title":"Temple.Html.var/0","type":"macro","doc":"The HTML Variable element (&lt;var&gt;) represents the name of a variable in a mathematical expression or a programming context."},{"ref":"Temple.Html.html#video/0","title":"Temple.Html.video/0","type":"macro","doc":"The HTML Video element (&lt;video&gt;) embeds a media player which supports video playback into the document."},{"ref":"Temple.Html.html#wbr/1","title":"Temple.Html.wbr/1","type":"macro","doc":"The HTML &lt;wbr&gt; element represents a word break opportunity—a position within text where the browser may optionally break a line, though its line-breaking rules would not otherwise create a break at that location."},{"ref":"Temple.Link.html","title":"Temple.Link","type":"module","doc":"This modules wraps all of the functions from the Phoenix.HTML.Link module to make them compatible with with Temple."},{"ref":"Temple.Link.html#phx_button/2","title":"Temple.Link.phx_button/2","type":"macro","doc":"Please see Phoenix.HTML.Link.button/2 for details."},{"ref":"Temple.Link.html#phx_link/2","title":"Temple.Link.phx_link/2","type":"macro","doc":"Please see Phoenix.HTML.Link.link/2 for details."},{"ref":"Temple.Svg.html","title":"Temple.Svg","type":"module","doc":"The Temple.Svg module defines macros for all SVG elements. Usage is the same as Temple.Html."},{"ref":"Temple.Svg.html#animate/0","title":"Temple.Svg.animate/0","type":"macro","doc":"This element implements the SVGAnimateElement interface."},{"ref":"Temple.Svg.html#animateMotion/0","title":"Temple.Svg.animateMotion/0","type":"macro","doc":"The &lt;animateMotion&gt; element causes a referenced element to move along a motion path."},{"ref":"Temple.Svg.html#animateTransform/0","title":"Temple.Svg.animateTransform/0","type":"macro","doc":"The animateTransform element animates a transformation attribute on its target element, thereby allowing animations to control translation, scaling, rotation, and/or skewing."},{"ref":"Temple.Svg.html#circle/0","title":"Temple.Svg.circle/0","type":"macro","doc":"The &lt;circle&gt; SVG element is an SVG basic shape, used to draw circles based on a center point and a radius."},{"ref":"Temple.Svg.html#clipPath/0","title":"Temple.Svg.clipPath/0","type":"macro","doc":"The &lt;clipPath&gt; SVG element defines a clipping path, to be used used by the clip-path property."},{"ref":"Temple.Svg.html#color_profile/0","title":"Temple.Svg.color_profile/0","type":"macro","doc":"The &lt;color-profile&gt; element allows describing the color profile used for the image."},{"ref":"Temple.Svg.html#defs/0","title":"Temple.Svg.defs/0","type":"macro","doc":"The &lt;defs&gt; element is used to store graphical objects that will be used at a later time. Objects created inside a &lt;defs&gt; element are not rendered directly. To display them you have to reference them (with a &lt;use&gt; element for example)."},{"ref":"Temple.Svg.html#desc/0","title":"Temple.Svg.desc/0","type":"macro","doc":"The &lt;desc&gt; element provides an accessible, long-text description of any SVG container element or graphics element."},{"ref":"Temple.Svg.html#discard/0","title":"Temple.Svg.discard/0","type":"macro","doc":"The &lt;discard&gt; SVG element allows authors to specify the time at which particular elements are to be discarded, thereby reducing the resources required by an SVG user agent. This is particularly useful to help SVG viewers conserve memory while displaying long-running documents."},{"ref":"Temple.Svg.html#ellipse/0","title":"Temple.Svg.ellipse/0","type":"macro","doc":"The &lt;ellipse&gt; element is an SVG basic shape, used to create ellipses based on a center coordinate, and both their x and y radius."},{"ref":"Temple.Svg.html#feBlend/0","title":"Temple.Svg.feBlend/0","type":"macro","doc":"The &lt;feBlend&gt; SVG filter primitive composes two objects together ruled by a certain blending mode. This is similar to what is known from image editing software when blending two layers. The mode is defined by the mode attribute."},{"ref":"Temple.Svg.html#feColorMatrix/0","title":"Temple.Svg.feColorMatrix/0","type":"macro","doc":"The &lt;feColorMatrix&gt; SVG filter element changes colors based on a transformation matrix. Every pixel&#39;s color value (represented by an [R,G,B,A] vector) is matrix multiplied to create a new color:"},{"ref":"Temple.Svg.html#feComponentTransfer/0","title":"Temple.Svg.feComponentTransfer/0","type":"macro","doc":"Th &lt;feComponentTransfer&gt; SVG filter primitive performs color-component-wise remapping of data for each pixel. It allows operations like brightness adjustment, contrast adjustment, color balance or thresholding."},{"ref":"Temple.Svg.html#feComposite/0","title":"Temple.Svg.feComposite/0","type":"macro","doc":"The &lt;feComposite&gt; SVG filter primitive performs the combination of two input images pixel-wise in image space using one of the Porter-Duff compositing operations: over, in, atop, out, xor, and lighter. Additionally, a component-wise arithmetic operation (with the result clamped between [0..1]) can be applied."},{"ref":"Temple.Svg.html#feConvolveMatrix/0","title":"Temple.Svg.feConvolveMatrix/0","type":"macro","doc":"The &lt;feConvolveMatrix&gt; SVG filter primitive applies a matrix convolution filter effect. A convolution combines pixels in the input image with neighboring pixels to produce a resulting image. A wide variety of imaging operations can be achieved through convolutions, including blurring, edge detection, sharpening, embossing and beveling."},{"ref":"Temple.Svg.html#feDiffuseLighting/0","title":"Temple.Svg.feDiffuseLighting/0","type":"macro","doc":"The &lt;feDiffuseLighting&gt; SVG filter primitive lights an image using the alpha channel as a bump map. The resulting image, which is an RGBA opaque image, depends on the light color, light position and surface geometry of the input bump map."},{"ref":"Temple.Svg.html#feDisplacementMap/0","title":"Temple.Svg.feDisplacementMap/0","type":"macro","doc":"The &lt;feDisplacementMap&gt; SVG filter primitive uses the pixel values from the image from in2 to spatially displace the image from in."},{"ref":"Temple.Svg.html#feDistantLight/0","title":"Temple.Svg.feDistantLight/0","type":"macro","doc":"The &lt;feDistantLight&gt; filter primitive defines a distant light source that can be used within a lighting filter primitive: &lt;feDiffuseLighting&gt; or &lt;feSpecularLighting&gt;."},{"ref":"Temple.Svg.html#feDropShadow/0","title":"Temple.Svg.feDropShadow/0","type":"macro","doc":"The SVG &lt;feDropShadow&gt; filter primitive creates a drop shadow of the input image. It can only be used inside a &lt;filter&gt; element."},{"ref":"Temple.Svg.html#feFlood/0","title":"Temple.Svg.feFlood/0","type":"macro","doc":"The &lt;feFlood&gt; SVG filter primitive fills the filter subregion with the color and opacity defined by flood-color and flood-opacity."},{"ref":"Temple.Svg.html#feFuncA/0","title":"Temple.Svg.feFuncA/0","type":"macro","doc":"The &lt;feFuncA&gt; SVG filter primitive defines the transfer function for the alpha component of the input graphic of its parent &lt;feComponentTransfer&gt; element."},{"ref":"Temple.Svg.html#feFuncB/0","title":"Temple.Svg.feFuncB/0","type":"macro","doc":"The &lt;feFuncB&gt; SVG filter primitive defines the transfer function for the blue component of the input graphic of its parent &lt;feComponentTransfer&gt; element."},{"ref":"Temple.Svg.html#feFuncG/0","title":"Temple.Svg.feFuncG/0","type":"macro","doc":"The &lt;feFuncG&gt; SVG filter primitive defines the transfer function for the green component of the input graphic of its parent &lt;feComponentTransfer&gt; element."},{"ref":"Temple.Svg.html#feFuncR/0","title":"Temple.Svg.feFuncR/0","type":"macro","doc":"The &lt;feFuncR&gt; SVG filter primitive defines the transfer function for the red component of the input graphic of its parent &lt;feComponentTransfer&gt; element."},{"ref":"Temple.Svg.html#feGaussianBlur/0","title":"Temple.Svg.feGaussianBlur/0","type":"macro","doc":"The &lt;feGaussianBlur&gt; SVG filter primitive blurs the input image by the amount specified in stdDeviation, which defines the bell-curve."},{"ref":"Temple.Svg.html#feImage/0","title":"Temple.Svg.feImage/0","type":"macro","doc":"The &lt;feImage&gt; SVG filter primitive fetches image data from an external source and provides the pixel data as output (meaning if the external source is an SVG image, it is rasterized.)"},{"ref":"Temple.Svg.html#feMerge/0","title":"Temple.Svg.feMerge/0","type":"macro","doc":"The &lt;feMerge&gt; SVG element allows filter effects to be applied concurrently instead of sequentially. This is achieved by other filters storing their output via the result attribute and then accessing it in a &lt;feMergeNode&gt; child."},{"ref":"Temple.Svg.html#feMergeNode/0","title":"Temple.Svg.feMergeNode/0","type":"macro","doc":"The feMergeNode takes the result of another filter to be processed by its parent &lt;feMerge&gt;."},{"ref":"Temple.Svg.html#feMorphology/0","title":"Temple.Svg.feMorphology/0","type":"macro","doc":"The &lt;feMorphology&gt; SVG filter primitive is used to erode or dilate the input image. It&#39;s usefulness lies especially in fattening or thinning effects."},{"ref":"Temple.Svg.html#feOffset/0","title":"Temple.Svg.feOffset/0","type":"macro","doc":"The &lt;feOffset&gt; SVG filter primitive allows to offset the input image. The input image as a whole is offset by the values specified in the dx and dy attributes."},{"ref":"Temple.Svg.html#fePointLight/0","title":"Temple.Svg.fePointLight/0","type":"macro","doc":"The &lt;fePointLight&gt; filter primitive defines a light source which allows to create a point light effect. It that can be used within a lighting filter primitive: &lt;feDiffuseLighting&gt; or &lt;feSpecularLighting&gt;."},{"ref":"Temple.Svg.html#feSpecularLighting/0","title":"Temple.Svg.feSpecularLighting/0","type":"macro","doc":"The &lt;feSpecularLighting&gt; SVG filter primitive lights a source graphic using the alpha channel as a bump map. The resulting image is an RGBA image based on the light color. The lighting calculation follows the standard specular component of the Phong lighting model. The resulting image depends on the light color, light position and surface geometry of the input bump map. The result of the lighting calculation is added. The filter primitive assumes that the viewer is at infinity in the z direction."},{"ref":"Temple.Svg.html#feSpotLight/0","title":"Temple.Svg.feSpotLight/0","type":"macro","doc":"The &lt;feSpotLight&gt; SVG filter primitive defines a light source which allows to create a spotlight effect. It that can be used within a lighting filter primitive: &lt;feDiffuseLighting&gt; or &lt;feSpecularLighting&gt;."},{"ref":"Temple.Svg.html#feTile/0","title":"Temple.Svg.feTile/0","type":"macro","doc":"The &lt;feTile&gt; SVG filter primitive allows to fill a target rectangle with a repeated, tiled pattern of an input image. The effect is similar to the one of a &lt;pattern&gt;."},{"ref":"Temple.Svg.html#feTurbulence/0","title":"Temple.Svg.feTurbulence/0","type":"macro","doc":"The &lt;feTurbulence&gt; SVG filter primitive creates an image using the Perlin turbulence function. It allows the synthesis of artificial textures like clouds or marble. The resulting image will fill the entire filter primitive subregion."},{"ref":"Temple.Svg.html#filter/0","title":"Temple.Svg.filter/0","type":"macro","doc":"The &lt;filter&gt; SVG element defines a custom filter effect by grouping atomic filter primitives. It is never rendered itself, but must be used by the filter attribute on SVG elements, or the filter CSS property for SVG/HTML elements."},{"ref":"Temple.Svg.html#foreignObject/0","title":"Temple.Svg.foreignObject/0","type":"macro","doc":"The &lt;foreignObject&gt; SVG element includes elements from a different XML namespace. In the context of a browser, it is most likely (X)HTML."},{"ref":"Temple.Svg.html#g/0","title":"Temple.Svg.g/0","type":"macro","doc":"The &lt;g&gt; SVG element is a container used to group other SVG elements."},{"ref":"Temple.Svg.html#hatch/0","title":"Temple.Svg.hatch/0","type":"macro","doc":"The &lt;hatch&gt; SVG element is used to fill or stroke an object using one or more pre-defined paths that are repeated at fixed intervals in a specified direction to cover the areas to be painted."},{"ref":"Temple.Svg.html#hatchpath/0","title":"Temple.Svg.hatchpath/0","type":"macro","doc":"The &lt;hatchpath&gt; SVG element defines a hatch path used by the &lt;hatch&gt; element."},{"ref":"Temple.Svg.html#image/0","title":"Temple.Svg.image/0","type":"macro","doc":"The &lt;image&gt; SVG element includes images inside SVG documents. It can display raster image files or other SVG files."},{"ref":"Temple.Svg.html#line/0","title":"Temple.Svg.line/0","type":"macro","doc":"The &lt;line&gt; element is an SVG basic shape used to create a line connecting two points."},{"ref":"Temple.Svg.html#linearGradient/0","title":"Temple.Svg.linearGradient/0","type":"macro","doc":"The &lt;linearGradient&gt; element lets authors define linear gradients that can be applied to fill or stroke of graphical elements."},{"ref":"Temple.Svg.html#marker/0","title":"Temple.Svg.marker/0","type":"macro","doc":"The &lt;marker&gt; element defines the graphic that is to be used for drawing arrowheads or polymarkers on a given &lt;path&gt;, &lt;line&gt;, &lt;polyline&gt; or &lt;polygon&gt; element."},{"ref":"Temple.Svg.html#mask/0","title":"Temple.Svg.mask/0","type":"macro","doc":"The &lt;mask&gt; element defines an alpha mask for compositing the current object into the background. A mask is used/referenced using the mask property."},{"ref":"Temple.Svg.html#metadata/0","title":"Temple.Svg.metadata/0","type":"macro","doc":"The &lt;metadata&gt; SVG element adds metadata to SVG content. Metadata is structured information about data. The contents of &lt;metadata&gt; should be elements from other XML namespaces such as RDF, FOAF, etc."},{"ref":"Temple.Svg.html#mpath/0","title":"Temple.Svg.mpath/0","type":"macro","doc":"The &lt;mpath&gt; sub-element for the &lt;animateMotion&gt; element provides the ability to reference an external &lt;path&gt; element as the definition of a motion path."},{"ref":"Temple.Svg.html#path/0","title":"Temple.Svg.path/0","type":"macro","doc":"The &lt;path&gt; SVG element is the generic element to define a shape. All the basic shapes can be created with a path element."},{"ref":"Temple.Svg.html#pattern/0","title":"Temple.Svg.pattern/0","type":"macro","doc":"The &lt;pattern&gt; element defines a graphics object which can be redrawn at repeated x and y-coordinate intervals (&quot;tiled&quot;) to cover an area."},{"ref":"Temple.Svg.html#polygon/0","title":"Temple.Svg.polygon/0","type":"macro","doc":"The &lt;polygon&gt; element defines a closed shape consisting of a set of connected straight line segments. The last point is connected to the first point. For open shapes see the &lt;polyline&gt; element."},{"ref":"Temple.Svg.html#polyline/0","title":"Temple.Svg.polyline/0","type":"macro","doc":"The &lt;polyline&gt; SVG element is an SVG basic shape that creates straight lines connecting several points. Typically a polyline is used to create open shapes as the last point doesn&#39;t have to be connected to the first point. For closed shapes see the &lt;polygon&gt; element."},{"ref":"Temple.Svg.html#radialGradient/0","title":"Temple.Svg.radialGradient/0","type":"macro","doc":"The &lt;radialGradient&gt; element lets authors define radial gradients that can be applied to fill or stroke of graphical elements."},{"ref":"Temple.Svg.html#rect/0","title":"Temple.Svg.rect/0","type":"macro","doc":"The &lt;rect&gt; element is a basic SVG shape that draws rectangles, defined by their position, width, and height. The rectangles may have their corners rounded."},{"ref":"Temple.Svg.html#set/0","title":"Temple.Svg.set/0","type":"macro","doc":"The &lt;set&gt; element provides a simple means of just setting the value of an attribute for a specified duration. It supports all attribute types, including those that cannot reasonably be interpolated, such as string and boolean values. The &lt;set&gt; element is non-additive. The additive and accumulate attributes are not allowed, and will be ignored if specified."},{"ref":"Temple.Svg.html#solidcolor/0","title":"Temple.Svg.solidcolor/0","type":"macro","doc":"The &lt;solidcolor&gt; SVG element lets authors define a single color for use in multiple places in an SVG document. It is also useful as away of animating a palette colors."},{"ref":"Temple.Svg.html#stop/0","title":"Temple.Svg.stop/0","type":"macro","doc":"The SVG &lt;stop&gt; element defines a color and its position to use on a gradient. This element is always a child of a &lt;linearGradient&gt; or &lt;radialGradient&gt; element."},{"ref":"Temple.Svg.html#svg/0","title":"Temple.Svg.svg/0","type":"macro","doc":"The svg element is a container that defines a new coordinate system and viewport. It is used as the outermost element of SVG documents, but it can also be used to embed a SVG fragment inside an SVG or HTML document."},{"ref":"Temple.Svg.html#switch/0","title":"Temple.Svg.switch/0","type":"macro","doc":"The &lt;switch&gt; SVG element evaluates any requiredFeatures, requiredExtensions and systemLanguage attributes on its direct child elements in order, and then renders the first child where these attributes evaluate to true."},{"ref":"Temple.Svg.html#symbol/0","title":"Temple.Svg.symbol/0","type":"macro","doc":"The &lt;symbol&gt; element is used to define graphical template objects which can be instantiated by a &lt;use&gt; element."},{"ref":"Temple.Svg.html#textPath/0","title":"Temple.Svg.textPath/0","type":"macro","doc":"To render text along the shape of a &lt;path&gt;, enclose the text in a &lt;textPath&gt; element that has an href attribute with a reference to the &lt;path&gt; element."},{"ref":"Temple.Svg.html#text_/0","title":"Temple.Svg.text_/0","type":"macro","doc":"The SVG &lt;text&gt; element draws a graphics element consisting of text. It&#39;s possible to apply a gradient, pattern, clipping path, mask, or filter to &lt;text&gt;, like any other SVG graphics element."},{"ref":"Temple.Svg.html#tspan/0","title":"Temple.Svg.tspan/0","type":"macro","doc":"The SVG &lt;tspan&gt; element define a subtext within a &lt;text&gt; element or another &lt;tspan&gt; element. It allows to adjust the style and/or position of that subtext as needed."},{"ref":"Temple.Svg.html#use/0","title":"Temple.Svg.use/0","type":"macro","doc":"The &lt;use&gt; element takes nodes from within the SVG document, and duplicates them somewhere else."},{"ref":"Temple.Svg.html#view/0","title":"Temple.Svg.view/0","type":"macro","doc":"A view is a defined way to view the image, like a zoom level or a detail view."},{"ref":"readme.html","title":"","type":"extras","doc":"Temple is a DSL for writing HTML using Elixir. You&#39;re probably here because you want to use Temple to write Phoenix templates, which is why Temple includes a Phoenix template engine and Temple-compatible Phoenix form helpers."},{"ref":"readme.html#installation","title":" - Installation","type":"extras","doc":"Add temple to your list of dependencies in mix.exs: def deps do [{:temple, &quot;~&gt; 0.4.0&quot;}] end"},{"ref":"readme.html#usage","title":" - Usage","type":"extras","doc":"Using Temple is a as simple as using the DSL inside of an temple/1 block. This returns a safe result of the form {:safe, html_string}. See the documentation for more details. use Temple temple do h2 &quot;todos&quot; ul class: &quot;list&quot; do for item &lt;- @items do li class: &quot;item&quot; do div class: &quot;checkbox&quot; do div class: &quot;bullet hidden&quot; end div item end end end script &quot;&quot;&quot; function toggleCheck({currentTarget}) { currentTarget.children[0].children[0].classList.toggle(&quot;hidden&quot;); } let items = document.querySelectorAll(&quot;li&quot;); Array.from(items).forEach(checkbox =&gt; checkbox.addEventListener(&quot;click&quot;, toggleCheck)); &quot;&quot;&quot; end Components Temple provides an API for creating custom components that act as custom HTML elements. These components can be given props that are available inside the component definition as module attributes. The contents of a components do block are available as a special @children attribute. See the documentation for more details. defcomponent :flex do div id: @id, class: &quot;flex&quot; do @children end end temple do flex id: &quot;my-flex&quot; do div &quot;Item 1&quot; div &quot;Item 2&quot; div &quot;Item 3&quot; end end Phoenix.HTML Temple provides macros for working with the helpers provided by the Phoenix.HTML package. Most of the macros are purely wrappers, while the semantics of some are changed to work with Temple. See the documentation for more details. temple do form_for @conn, Routes.some_path(@conn, :create) do text_input form, :name end end Phoenix templates Add the templating engine to your Phoenix configuration. See the documentation for more details. # config.exs config :phoenix, :template_engines, exs: Temple.Engine # your_app_web.ex def view do quote do # ... use Temple # Replaces the call to import Phoenix.HTML end end # app.html.exs html lang: &quot;en&quot; do head do meta charset: &quot;utf-8&quot; meta http_equiv: &quot;X-UA-Compatible&quot;, content: &quot;IE=edge&quot; meta name: &quot;viewport&quot;, content: &quot;width=device-width, initial-scale=1.0&quot; title &quot;YourApp · Phoenix Framework&quot; link rel: &quot;stylesheet&quot;, href: Routes.static_path(@conn, &quot;/css/app.css&quot;) end body do header do section class: &quot;container&quot; do nav role: &quot;navigation&quot; do ul do li do: a(&quot;Get Started&quot;, href: &quot;https://hexdocs.pm/phoenix/overview.html&quot;) end end a href: &quot;http://phoenixframework.org/&quot;, class: &quot;phx-logo&quot; do img src: Routes.static_path(@conn, &quot;/images/phoenix.png&quot;), alt: &quot;Phoenix Framework Logo&quot; end end end main role: &quot;main&quot;, class: &quot;container&quot; do p get_flash(@conn, :info), class: &quot;alert alert-info&quot;, role: &quot;alert&quot; p get_flash(@conn, :error), class: &quot;alert alert-danger&quot;, role: &quot;alert&quot; partial render(@view_module, @view_template, assigns) end script type: &quot;text/javascript&quot;, src: Routes.static_path(@conn, &quot;/js/app.js&quot;) end end Tasks temple.convert This task can be used to convert plain HTML and SVG into Temple syntax. Input is taken from stdin or from a file and the output is sent to stdout. cat index.html | mix temple.convert &gt; index.html.exs Formatter To include Temple&#39;s formatter configuration, add :temple to your .formatter.exs. [ import_deps: [:temple], inputs: [&quot;*.{ex,exs}&quot;, &quot;priv/*/seeds.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs}&quot;], ]"}]